#include <windows.h>
#include <stdio.h>
#include <process.h>
#include "amxxmodule.h"

char g_url[10][MAX_PATH];
char g_file[10][MAX_PATH];
int g_idstatus[10];

int fw_Downloading;
int fw_DownloadDone;
int fw_DownloadFailed;

void DownloadThread0(void *dummy);
void DownloadThread1(void *dummy);
void DownloadThread2(void *dummy);
void DownloadThread3(void *dummy);
void DownloadThread4(void *dummy);
void DownloadThread5(void *dummy);
void DownloadThread6(void *dummy);
void DownloadThread7(void *dummy);
void DownloadThread8(void *dummy);
void DownloadThread9(void *dummy);

void ErrorWrapper(int CustomErrornum = -666, const char szCustomError[] = "") {

	if ( strlen(szCustomError) )
		printf("[%s] Error: %s\n", MODULE_NAME, szCustomError);

	else {

		DWORD dwRC = NULL;
		DWORD dwError = CustomErrornum;
		if ( CustomErrornum == -666 )
			dwError = GetLastError();
		LPVOID lpMsgBuf;
		lpMsgBuf = NULL;

		dwRC = FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER
			|FORMAT_MESSAGE_FROM_SYSTEM
			|FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			dwError,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPTSTR) &lpMsgBuf,
			0,
			NULL);

		if ( dwRC && lpMsgBuf )
			printf("[%s] Error %d: %s\n", MODULE_NAME, dwError, lpMsgBuf);
		else
			printf("[%s] Error %d\n", MODULE_NAME, dwError);
	}
}

bool CompareStrings(char str1[], char str2[]) {
	int i = 0;

	while ( i < MAX_PATH ) {
		if ( str1[i] == 0 && str2[i] == 0 )
			return true;
		if ( str1[i] == 0 && str2[i] == '/' && str2[i+1] == 0 )
			return true;
		if ( tolower(str1[i]) != tolower(str2[i]) )
			return false;
		i++;
	}
	return true;
}

int FindCurFile(char* filename) {	
	int i = 0;

	while ( i < 10 ) {
		if ( CompareStrings(g_url[i], filename) )
			return i;
		i++;
	}
	return -1;
}

int FindFreeId() {	
	int i = 0;

	while ( i < 10 ) {
		if ( g_idstatus[i] == 0 ) {
			return i;
		}
		i++;
	}
	return -1;
}

bool IsFileDownloadingAlready(char* filename) {	
	int i = 0;

	while ( i < 10 ) {
		if ( strcmp(g_url[i], filename) == 0 ) {
			return true;
		}
		i++;
	}
	return false;
}

class MyCallback : public IBindStatusCallback {

STDMETHOD(OnProgress)(/* [in] */ ULONG ulProgress, /* [in] */ ULONG ulProgressMax, /* [in] */ ULONG ulStatusCode, /* [in] */ LPCWSTR wszStatusText) {
	
	char curfile[MAX_PATH];
	WideCharToMultiByte(CP_ACP, 0, wszStatusText, -1, curfile, MAX_PATH-1, 0, 0);

	int curId = FindCurFile(curfile);

	if ( ulStatusCode == BINDSTATUS_DOWNLOADINGDATA )
		MF_ExecuteForward(fw_Downloading, curId, ( ulProgress / 1024 ), ( ulProgressMax / 1024 ) );
	
	if ( ulStatusCode == BINDSTATUS_ENDDOWNLOADDATA )
		MF_ExecuteForward(fw_DownloadDone, curId, ( ulProgress / 1024 ), ( ulProgressMax / 1024 ) );
	
	if ( g_idstatus[curId] == -1 ) {
		g_idstatus[curId] = 0;
		memset(g_url[curId], 0, MAX_PATH-1);
		memset(g_file[curId], 0, MAX_PATH-1);
		return E_ABORT;
	}
	return S_OK;
}

STDMETHOD(OnStartBinding)(/* [in] */ DWORD dwReserved, /* [in] */ IBinding __RPC_FAR *pib) { return E_NOTIMPL; }
STDMETHOD(GetPriority)(/* [out] */ LONG __RPC_FAR *pnPriority) { return E_NOTIMPL; }
STDMETHOD(OnLowResource)(/* [in] */ DWORD reserved) { return E_NOTIMPL; }
STDMETHOD(OnStopBinding)(/* [in] */ HRESULT hresult, /* [unique][in] */ LPCWSTR szError) { return E_NOTIMPL; }
STDMETHOD(GetBindInfo)(/* [out] */ DWORD __RPC_FAR *grfBINDF, /* [unique][out][in] */ BINDINFO __RPC_FAR *pbindinfo) { return E_NOTIMPL; }
STDMETHOD(OnDataAvailable)(/* [in] */ DWORD grfBSCF, /* [in] */ DWORD dwSize, /* [in] */ FORMATETC __RPC_FAR *pformatetc, /* [in] */ STGMEDIUM __RPC_FAR *pstgmed) { return E_NOTIMPL; }
STDMETHOD(OnObjectAvailable)(/* [in] */ REFIID riid, /* [iid_is][in] */ IUnknown __RPC_FAR *punk) { return E_NOTIMPL; }
STDMETHOD_(ULONG,AddRef)() { return 0; }
STDMETHOD_(ULONG,Release)() { return 0; }
STDMETHOD(QueryInterface)(/* [in] */ REFIID riid, /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject) { return E_NOTIMPL; }
};

MyCallback pCallback;

void StartThread(int Id) {
	if ( Id == 0 )
		_beginthread(DownloadThread0, 0, NULL);

	if ( Id == 1 )
		_beginthread(DownloadThread1, 0, NULL);

	if ( Id == 2 )
		_beginthread(DownloadThread2, 0, NULL);

	if ( Id == 3 )
		_beginthread(DownloadThread3, 0, NULL);

	if ( Id == 4 )
		_beginthread(DownloadThread4, 0, NULL);

	if ( Id == 5 )
		_beginthread(DownloadThread5, 0, NULL);

	if ( Id == 6 )
		_beginthread(DownloadThread6, 0, NULL);

	if ( Id == 7 )
		_beginthread(DownloadThread7, 0, NULL);

	if ( Id == 8 )
		_beginthread(DownloadThread8, 0, NULL);

	if ( Id == 9 )
		_beginthread(DownloadThread9, 0, NULL);
}

static cell AMX_NATIVE_CALL native_DownloadStart(AMX* amx ,cell* amxparams) {

	if ( IsFileDownloadingAlready(MF_GetAmxString(amx, amxparams[1], 0, NULL)) ){
		ErrorWrapper(0, "This file is already downloading.");
		return -1;
	}

	int Id = FindFreeId();

	if ( Id == -1 ) {
		ErrorWrapper(0, "All download slots are full.");
		return -1;
	}

	g_idstatus[Id] = 1;

	strcpy(g_url[Id], MF_GetAmxString(amx, amxparams[1], 0, NULL));
	strcpy(g_file[Id], MF_GetAmxString(amx, amxparams[2], 1, NULL));

	StartThread(Id);

	return Id;
}

static cell AMX_NATIVE_CALL native_DownloadAbort(AMX* amx ,cell* amxparams) {
	if ( 0 > amxparams[1] || amxparams[1] > 9 )
		return 0;
	g_idstatus[amxparams[1]] = -1;
	return 0;
}

AMX_NATIVE_INFO natives[] = {
	{ "DownloadStart", native_DownloadStart },
	{ "DownloadAbort", native_DownloadAbort },
	{ NULL, NULL }
};

void OnAmxxAttach() {
	MF_AddNatives(natives);
}

void OnPluginsLoaded() {
	/* forward Downloading(int Id, int KBDone, int KBTotal); */
	fw_Downloading = MF_RegisterForward("Downloading", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_DONE);

	/* forward DownloadDone(int Id, int KBDone, int KBTotal); */
	fw_DownloadDone = MF_RegisterForward("DownloadDone", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_DONE);

	/* forward DownloadFailed(int Id, int ErrorId); */
	fw_DownloadFailed = MF_RegisterForward("DownloadFailed", ET_IGNORE, FP_CELL, FP_CELL, FP_DONE);
}

void DownloadFailed(int Id, HRESULT hResult) {
	
	if ( hResult == INET_E_RESOURCE_NOT_FOUND )
		ErrorWrapper(0, "Server Down");

	else if ( hResult == INET_E_RESOURCE_NOT_FOUND )
		ErrorWrapper(0, "No such file on server");

	else ErrorWrapper();

	MF_ExecuteForward(fw_DownloadFailed, Id, hResult);
}

void DownloadThread0(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[0], g_file[0], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(0, hResult);

	g_idstatus[0] = 0;
	memset(g_url[0], 0, MAX_PATH-1);
	memset(g_file[0], 0, MAX_PATH-1);
	_endthread();
}

void DownloadThread1(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[1], g_file[1], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(1, hResult);

	g_idstatus[1] = 0;
	memset(g_url[1], 0, MAX_PATH-1);
	memset(g_file[1], 0, MAX_PATH-1);
	_endthread();
}

void DownloadThread2(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[2], g_file[2], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(2, hResult);

	g_idstatus[2] = 0;
	memset(g_url[2], 0, MAX_PATH-1);
	memset(g_file[2], 0, MAX_PATH-1);
	_endthread();
}

void DownloadThread3(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[3], g_file[3], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(3, hResult);

	g_idstatus[3] = 0;
	memset(g_url[3], 0, MAX_PATH-1);
	memset(g_file[3], 0, MAX_PATH-1);
	_endthread();
}

void DownloadThread4(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[4], g_file[4], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(4, hResult);

	g_idstatus[4] = 0;
	memset(g_url[4], 0, MAX_PATH-1);
	memset(g_file[4], 0, MAX_PATH-1);
	_endthread();
}

void DownloadThread5(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[5], g_file[5], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(5, hResult);

	g_idstatus[5] = 0;
	memset(g_url[5], 0, MAX_PATH-1);
	memset(g_file[5], 0, MAX_PATH-1);
	_endthread();
}

void DownloadThread6(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[6], g_file[6], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(6, hResult);

	g_idstatus[6] = 0;
	memset(g_url[6], 0, MAX_PATH-1);
	memset(g_file[6], 0, MAX_PATH-1);
	_endthread();
}

void DownloadThread7(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[7], g_file[7], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(7, hResult);

	g_idstatus[7] = 0;
	memset(g_url[7], 0, MAX_PATH-1);
	memset(g_file[7], 0, MAX_PATH-1);
	_endthread();
}

void DownloadThread8(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[8], g_file[8], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(8, hResult);

	g_idstatus[8] = 0;
	memset(g_url[8], 0, MAX_PATH-1);
	memset(g_file[8], 0, MAX_PATH-1);
	_endthread();
}

void DownloadThread9(void *dummy) {
	HRESULT hResult = URLDownloadToFile(0, g_url[9], g_file[9], 0, &pCallback);
	if ( hResult != 0 )
		DownloadFailed(9, hResult);

	g_idstatus[9] = 0;
	memset(g_url[9], 0, MAX_PATH-1);
	memset(g_file[9], 0, MAX_PATH-1);
	_endthread();
}